package j1.tutorial.javac.analysis.infrastructure;

import com.sun.source.tree.CompilationUnitTree;
import com.sun.source.util.JavacTask;
import j1.tutorial.javac.analysis.api.AnalysisContext;
import j1.tutorial.javac.analysis.api.Rule;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.ServiceLoader;
import javax.tools.JavaCompiler;
import javax.tools.StandardJavaFileManager;
import javax.tools.ToolProvider;

public class Main {
    public static void main(String... args) throws IOException {
        String classpath = "";
        List<String> toAnalyze = new ArrayList<>();
        
        for (int i = 0; i < args.length; i++) {
            String arg = args[i];
            
            if ("-classpath".equals(arg)) {
                if (++i < args.length) {
                    classpath = args[i];
                } else {
                    System.err.println("-classpath must specify a parameter");
                    System.exit(1);
                }
            } else {
                toAnalyze.add(arg);
            }
        }
        
        final String bootPath = System.getProperty("sun.boot.class.path"); //NOI18N
        final JavaCompiler tool = ToolProvider.getSystemJavaCompiler();
        assert tool != null;

        StandardJavaFileManager fm = tool.getStandardFileManager(null, null, null);
        final JavacTask ct = (JavacTask)tool.getTask(null, null, null, Arrays.asList("-bootclasspath",  bootPath, "-Xjcov", "-classpath", classpath, "-source", "1.6"), null, fm.getJavaFileObjects(toAnalyze.toArray(new String[0])));
        Iterable<? extends CompilationUnitTree> cuts = ct.parse();
        
        ct.analyze();
        
        for (CompilationUnitTree cut : cuts) {
            for (Rule r : ServiceLoader.load(Rule.class)) {
                r.analyseFile(new AnalysisContext(ct), cut);
            }
        }
    }
}
