/*
package j1.tutorial.javac.analysis.rules;

import j1.tutorial.javac.analysis.api.RuleTest;
import org.testng.annotations.Test;

public class FinalRuleNGTest {
    
    public FinalRuleNGTest() {
    }
    
    @Test
    public void testNotAllowedImplementor() throws Exception {
        RuleTest.create()
                .input("test/Test.java",
                       "package test;\n" +
                       "public class Test implements API {\n" +
                       "}\n")
                .input("test/API.java",
                       "package test;\n" +
                       "import j1.tutorial.javac.analysis.api.Final;\n" +
                       "@Final(implementors={})\n" +
                       "public interface API {\n" +
                       "}\n")
                .runProcessor(FinalRule.class)
                .assertWarnings("/test/Test.java:14-50:Cannot implement: test.API, not its listed implementor");
    }
    
    @Test
    public void testAllowedImplementor() throws Exception {
        RuleTest.create()
                .input("test/Test.java",
                       "package test;\n" +
                       "public class Test implements API {\n" +
                       "}\n")
                .input("test/API.java",
                       "package test;\n" +
                       "import j1.tutorial.javac.analysis.api.Final;\n" +
                       "@Final(implementors=Test.class)\n" +
                       "public interface API{\n" +
                       "}\n")
                .runProcessor(FinalRule.class)
                .assertWarnings();
    }
    
}
*/
