/*
package j1.tutorial.javac.analysis.rules;

import j1.tutorial.javac.analysis.api.RuleTest;
import org.testng.annotations.Test;

public class FriendRuleNGTest {
    
    public FriendRuleNGTest() {
    }
    
    @Test
    public void testNonFriendClass() throws Exception {
        RuleTest.create()
                .input("test/Test.java",
                       "package test;\n" +
                       "public class Test {\n" +
                       "     private NonAPI var;\n" +
                       "}\n")
                .input("test/NonAPI.java",
                       "package test;\n" +
                       "import j1.tutorial.javac.analysis.api.Friend;\n" +
                       "@Friend(friends={})\n" +
                       "public class NonAPI {\n" +
                       "}\n")
                .run(FriendRule.class)
                .assertWarnings("/test/Test.java:47-53:Cannot use: test.NonAPI, not its friend");
    }
    
    @Test
    public void testFriendClass() throws Exception {
        RuleTest.create()
                .input("test/Test.java",
                       "package test;\n" +
                       "public class Test {\n" +
                       "     private NonAPI var;\n" +
                       "}\n")
                .input("test/NonAPI.java",
                       "package test;\n" +
                       "import j1.tutorial.javac.analysis.api.Friend;\n" +
                       "@Friend(friends=Test.class)\n" +
                       "public class NonAPI{\n" +
                       "}\n")
                .run(FriendRule.class)
                .assertWarnings();
    }
    
    @Test
    public void testNonFriendMethod() throws Exception {
        RuleTest.create()
                .input("test/Test.java",
                       "package test;\n" +
                       "public class Test {\n" +
                       "     { NonAPI.call(); }\n" +
                       "}\n")
                .input("test/NonAPI.java",
                       "package test;\n" +
                       "import j1.tutorial.javac.analysis.api.Friend;\n" +
                       "public class NonAPI{\n" +
                       "     @Friend(friends={})\n" +
                       "     public static void call() { }\n" +
                       "}\n")
                .run(FriendRule.class)
                .assertWarnings("/test/Test.java:41-52:Cannot use: call(), not its friend");
    }
}
*/
