/*
package j1.tutorial.javac.analysis.rules;

import j1.tutorial.javac.analysis.api.RuleTest;
import org.testng.annotations.Test;

public class RegExpRuleNGTest {
    
    public RegExpRuleNGTest() {
    }
    
    @Test
    public void testSimpleFieldRegExp() throws Exception {
        RuleTest.create()
                .input("test/Test.java",
                       "package test;\n" +
                       "import j1.tutorial.javac.analysis.api.RegExp;\n" +
                       "public class Test {\n" +
                       "     @RegExp private final String MASK = \"(\";\n" +
                       "}\n")
                .run(RegExpRule.class)
                .assertWarnings("/test/Test.java:121-124:Unclosed group");
    }
    
    @Test
    public void testFieldRegExpReference() throws Exception {
        RuleTest.create()
                .input("test/Test.java",
                       "package test;\n" +
                       "import j1.tutorial.javac.analysis.api.RegExp;\n" +
                       "public class Test {\n" +
                       "     public static final String DEF_MASK = \"(\";\n" +
                       "     @RegExp private String MASK = DEF_MASK;\n" +
                       "}\n")
                .run(RegExpRule.class)
                .assertWarnings("/test/Test.java:163-171:Unclosed group");
    }
    
    @Test
    public void testFieldRegExpBinOp() throws Exception {
        RuleTest.create()
                .input("test/Test.java",
                       "package test;\n" +
                       "import j1.tutorial.javac.analysis.api.RegExp;\n" +
                       "public class Test {\n" +
                       "     public static final String DEF_MASK = \"(\";\n" +
                       "     @RegExp private final String MASK = DEF_MASK + \"a\";\n" +
                       "}\n")
                .run(RegExpRule.class)
                .assertWarnings("/test/Test.java:169-183:Unclosed group");
    }
    
    @Test
    public void testBrokenRegexp() throws Exception {
        RuleTest.create()
                .input("test/Test.java",
                       "package test;\n" +
                       "public class Test {\n" +
                       "     { API.validate(\"(\"); }\n" +
                       "}\n")
                .input("test/API.java",
                       "package test;\n" +
                       "import j1.tutorial.javac.analysis.api.RegExp;\n" +
                       "@RegExp\n" +
                       "public class API {\n" +
                       "    public static void validate(@RegExp String regExp) {}\n" +
                       "}\n")
                .run(RegExpRule.class)
                .assertWarnings("/test/Test.java:54-57:Unclosed group");
    }
    
    //TODO: much more tests
    
}
*/
